Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.common
Class AttributeValue

    java.lang.Object

      |

      +--oracle.ifs.common.AttributeValue

All Implemented Interfaces:
  java.lang.Cloneable, java.io.Serializable

public class AttributeValue
extends java.lang.Object
implements java.lang.Cloneable, java.io.Serializable

An AttributeValue represents the value of an Attribute of a LibraryObject.

An AttributeValue is instantiated any time a value needs to be represented. AttributeValues are implicitly created in getting the value of an Attribute. They may also be explicitly created using the `newAttributeValue` factory methods, in order to set the value of an Attribute in a LibraryObject or LibraryObjectDefinition.

In addition to the value itself, an AttributeValue tracks the data type, whether the value is an array-type, and whether the value is null. The class also provides methods to retrieve the value as various Java types, such as int, Integer, or String (not all of these are available for all AttributeValue data types). All of these conversion methods require a LibrarySession or S_LibrarySession argument. This session's Localizer is used to perform any needed localization (specifically, parsing and formatting numbers and dates).

AttributeValues also track the name of the Attribute whose value they represent. After you use a `newAttributeValue` method to create an AttributeValue, you can invoke the `setName` method to set its name. This is optional, unless you want to include the AttributeValue in an array passed to the `LibraryObject.setAttributes(AttributeValue[])` method. Note that once an AttributeValue's name is set, it cannot be altered except in limited ways using the `ensureUpperCaseName` and `overrideName` methods.

See Also:
  Serialized Form

Method Summary
`static java.util.Hashtable` | `arrayToHashtable(AttributeValue[] attrVals)` Converts an array of AttributeValues to a hashtable, hashed by name.
`void` | `ensureUpperCaseName()` Ensures the name of this AttributeValue (if any) is uppercase.
`boolean` | `getBoolean(LibrarySessionInterface session)` Gets this AttributeValue's representation as a boolean.
`boolean[]` | `getBooleanArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of booleans.
`boolean` | `getBooleanArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of booleans.
`java.lang.Boolean` | `getBooleanObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a Boolean.
`java.lang.Boolean[]` | `getBooleanObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of Booleans.
`java.lang.Boolean` | `getBooleanObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of Booleans.
`int` | `getDataType()` Gets the data type of this AttributeValue.
`java.util.Date` | `getDate(LibrarySessionInterface session)` Gets this AttributeValue's representation as a Date.
`java.util.Date[]` | `getDateArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of Dates.
`java.util.Date` | `getDateArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of Dates.
`DirectoryObjectInterface` | `getDirectoryObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a DirectoryObject.
`DirectoryObjectInterface[]` | `getDirectoryObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of DirectoryObjects.
`DirectoryObjectInterface` | `getDirectoryObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of DirectoryObjects.
`double` | `getDouble(LibrarySessionInterface session)` Gets this AttributeValue's representation as a double.
`double[]` | `getDoubleArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of doubles.
`double` | `getDoubleArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of doubles.
`java.lang.Double` | `getDoubleObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a Double.
`java.lang.Double[]` | `getDoubleObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of Doubles.
`java.lang.Double` | `getDoubleObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of Doubles.
`int` | `getElementCount()` Gets the number of elements in an array-type AttributeValue.
`int` | `getInteger(LibrarySessionInterface session)` Gets this AttributeValue's representation as an int.
`int[]` | `getIntegerArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of ints.
`int` | `getIntegerArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of ints.
`java.lang.Integer` | `getIntegerObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as an Integer.
`java.lang.Integer[]` | `getIntegerObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of Integers.
`java.lang.Integer` | `getIntegerObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of Integers.
`long` | `getLong(LibrarySessionInterface session)` Gets this AttributeValue's representation as a long.
`long[]` | `getLongArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of longs.
`long` | `getLongArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of longs.
`java.lang.Long` | `getLongObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a Long.
`java.lang.Long[]` | `getLongObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of Longs.
`java.lang.Long` | `getLongObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of Longs.
`java.lang.String` | `getName()` Gets the name of this AttributeValue.
`java.lang.Object` | `getObject(LibrarySessionInterface session)` Gets the default object representation of this AttributeValue.
`PublicObjectInterface` | `getPublicObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a PublicObject.
`PublicObjectInterface[]` | `getPublicObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of PublicObjects.
`PublicObjectInterface` | `getPublicObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of PublicObjects.
`SchemaObjectInterface` | `getSchemaObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a SchemaObject.
`SchemaObjectInterface[]` | `getSchemaObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of SchemaObjects.
`SchemaObjectInterface` | `getSchemaObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of SchemaObjects.
`java.lang.String` | `getString(LibrarySessionInterface session)` Gets this AttributeValue's representation as a String.
`java.lang.String[]` | `getStringArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of Strings.
`java.lang.String` | `getStringArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of Strings.
`SystemObjectInterface` | `getSystemObject(LibrarySessionInterface session)` Gets this AttributeValue's representation as a SystemObject.
`SystemObjectInterface[]` | `getSystemObjectArray(LibrarySessionInterface session)` Gets this AttributeValue's representation as an array of SystemObjects.
`SystemObjectInterface` | `getSystemObjectArray(LibrarySessionInterface session, int index)` Get the specified element of this AttributeValue's representation as an array of SystemObjects.
`static AttributeValue[]` | `hashtableToArray(java.util.Hashtable hashtable)` Converts a hashtable of AttributeValues to an array.
`boolean` | `isArrayType()` Gets whether this AttributeValue is an array-type AttributeValue.
`boolean` | `isNullValue()` Gets whether this AttributeValue is null.
`static AttributeValue` | `newAttributeValue()` Constructs a null AttributeValue of an unknown data type.
`static AttributeValue` | `newAttributeValue(AttributeValue av)` Constructs a new AttributeValue identical to the specified AttributeValue except with no name.
`static AttributeValue` | `newAttributeValue(boolean value)` Constructs a new boolean AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Boolean value)` Constructs a new boolean AttributeValue.
`static AttributeValue` | `newAttributeValue(boolean[] values)` Constructs a new array-type boolean AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Boolean[] values)` Constructs a new array-type boolean AttributeValue.
`static AttributeValue` | `newAttributeValue(java.util.Date value)` Constructs a new date AttributeValue.
`static AttributeValue` | `newAttributeValue(java.util.Date[] values)` Constructs a new array-type date AttributeValue.
`static AttributeValue` | `newAttributeValue(DirectoryObjectInterface value)` Constructs a new DirectoryObject AttributeValue.
`static AttributeValue` | `newAttributeValue(DirectoryObjectInterface[] values)` Constructs a new array-type DirectoryObject AttributeValue.
`static AttributeValue` | `newAttributeValue(double value)` Constructs a new double AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Double value)` Constructs a new double AttributeValue.
`static AttributeValue` | `newAttributeValue(double[] values)` Constructs a new array-type double AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Double[] values)` Constructs a new array-type double AttributeValue.
`static AttributeValue` | `newAttributeValue(int value)` Constructs a new integer AttributeValue.
`static AttributeValue` | `newAttributeValue(int[] values)` Constructs a new array-type integer AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Integer value)` Constructs a new integer AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Integer[] values)` Constructs a new array-type integer AttributeValue.
`static AttributeValue` | `newAttributeValue(long value)` Constructs a new long AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Long value)` Constructs a new long AttributeValue.
`static AttributeValue` | `newAttributeValue(long[] values)` Constructs a new array-type long AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Long[] values)` Constructs a new array-type long AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.Object value)` Constructs a new AttributeValue for the specified object.
`static AttributeValue` | `newAttributeValue(PublicObjectInterface value)` Constructs a new PublicObject AttributeValue.
`static AttributeValue` | `newAttributeValue(PublicObjectInterface[] values)` Constructs a new array-type PublicObject AttributeValue.
`static AttributeValue` | `newAttributeValue(SchemaObjectInterface value)` Constructs a new SchemaObject AttributeValue.
`static AttributeValue` | `newAttributeValue(SchemaObjectInterface[] values)` Constructs a new array-type SchemaObject AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.String value)` Constructs a new string AttributeValue.
`static AttributeValue` | `newAttributeValue(java.lang.String[] values)` Constructs a new array-type string AttributeValue.
`static AttributeValue` | `newAttributeValue(SystemObjectInterface value)` Constructs a new SystemObject AttributeValue.
`static AttributeValue` | `newAttributeValue(SystemObjectInterface[] values)` Constructs a new array-type SystemObject AttributeValue.
`static AttributeValue` | `newNullAttributeValue(int attributeDataType)` Constructs a null AttributeValue of the specified data type.
`static AttributeValue` | `overrideName(java.lang.String name, AttributeValue av)` Overrides the name set for this AttributeValue by cloning the AttributeValue if the name is already set.
`void` | `setName(java.lang.String name)` Sets the name of this AttributeValue.
`java.lang.String` | `toString()` Gets the default object representation of this AttributeValue as a string.
`java.lang.String` | `toString(LibrarySessionInterface sess)` Gets the default object representation of this AttributeValue as a string.

Method Detail

### newAttributeValue

    public static final AttributeValue newAttributeValue(int value)
                                                  throws IfsException

  Constructs a new integer AttributeValue.
  Parameters:
    `value` - the integer value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Integer value)
                                                  throws IfsException

  Constructs a new integer AttributeValue.
  Parameters:
    `value` - the integer value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(long value)
                                                  throws IfsException

  Constructs a new long AttributeValue.
  Parameters:
    `value` - the long value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Long value)
                                                  throws IfsException

  Constructs a new long AttributeValue.
  Parameters:
    `value` - the long value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(double value)
                                                  throws IfsException

  Constructs a new double AttributeValue.
  Parameters:
    `value` - the double value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Double value)
                                                  throws IfsException

  Constructs a new double AttributeValue.
  Parameters:
    `value` - the double value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.String value)
                                                  throws IfsException

  Constructs a new string AttributeValue.
  Parameters:
    `value` - the string value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.util.Date value)
                                                  throws IfsException

  Constructs a new date AttributeValue.
  Parameters:
    `value` - the date value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(boolean value)
                                                  throws IfsException

  Constructs a new boolean AttributeValue.
  Parameters:
    `value` - the boolean value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Boolean value)
                                                  throws IfsException

  Constructs a new boolean AttributeValue.
  Parameters:
    `value` - the boolean value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(SchemaObjectInterface value)
                                                  throws IfsException

  Constructs a new SchemaObject AttributeValue.
  Parameters:
    `value` - the SchemaObject value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(SystemObjectInterface value)
                                                  throws IfsException

  Constructs a new SystemObject AttributeValue.
  Parameters:
    `value` - the SystemObject value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(PublicObjectInterface value)
                                                  throws IfsException

  Constructs a new PublicObject AttributeValue.
  Parameters:
    `value` - the PublicObject value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(DirectoryObjectInterface value)
                                                  throws IfsException

  Constructs a new DirectoryObject AttributeValue.
  Parameters:
    `value` - the DirectoryObject value
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(int[] values)
                                                  throws IfsException

  Constructs a new array-type integer AttributeValue.
  Parameters:
    `values` - the integer values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Integer[] values)
                                                  throws IfsException

  Constructs a new array-type integer AttributeValue.
  Parameters:
    `values` - the integer values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(long[] values)
                                                  throws IfsException

  Constructs a new array-type long AttributeValue.
  Parameters:
    `values` - the long values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Long[] values)
                                                  throws IfsException

  Constructs a new array-type long AttributeValue.
  Parameters:
    `values` - the long values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(double[] values)
                                                  throws IfsException

  Constructs a new array-type double AttributeValue.
  Parameters:
    `values` - the double values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Double[] values)
                                                  throws IfsException

  Constructs a new array-type double AttributeValue.
  Parameters:
    `values` - the double values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.String[] values)
                                                  throws IfsException

  Constructs a new array-type string AttributeValue.
  Parameters:
    `values` - the string values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.util.Date[] values)
                                                  throws IfsException

  Constructs a new array-type date AttributeValue.
  Parameters:
    `values` - the date values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(boolean[] values)
                                                  throws IfsException

  Constructs a new array-type boolean AttributeValue.
  Parameters:
    `values` - the boolean values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Boolean[] values)
                                                  throws IfsException

  Constructs a new array-type boolean AttributeValue.
  Parameters:
    `values` - the boolean values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(SchemaObjectInterface[] values)
                                                  throws IfsException

  Constructs a new array-type SchemaObject AttributeValue.
  Parameters:
    `values` - the SchemaObject values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(SystemObjectInterface[] values)
                                                  throws IfsException

  Constructs a new array-type SystemObject AttributeValue.
  Parameters:
    `values` - the SystemObject values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(PublicObjectInterface[] values)
                                                  throws IfsException

  Constructs a new array-type PublicObject AttributeValue.
  Parameters:
    `values` - the PublicObject values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(DirectoryObjectInterface[] values)
                                                  throws IfsException

  Constructs a new array-type DirectoryObject AttributeValue.
  Parameters:
    `values` - the DirectoryObject values
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(AttributeValue av)
                                                  throws IfsException

  Constructs a new AttributeValue identical to the specified AttributeValue except with no name.
  Parameters:
    `av` - the existing AttributeValue
  Returns:
    the new nameless AttributeValue
  Throws:
    `IfsException` - if the operation fails

### newAttributeValue

    public static final AttributeValue newAttributeValue(java.lang.Object value)
                                                  throws IfsException

  Constructs a new AttributeValue for the specified object.
  Parameters:
    `value` - the object
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - (IFS-10403 or IFS-10404) if an AttributeValue cannot be constructed for `value`'s class

### newAttributeValue

    public static final AttributeValue newAttributeValue()
                                                  throws IfsException

  Constructs a null AttributeValue of an unknown data type.
  Returns:
    the new AttributeValue

### newNullAttributeValue

    public static final AttributeValue newNullAttributeValue(int attributeDataType)
                                                      throws IfsException

  Constructs a null AttributeValue of the specified data type.
  Parameters:
    `attributeDataType` - the Attribute data type
  Returns:
    the new AttributeValue
  Throws:
    `IfsException` - (IFS-10400) if `attributeDataType` is invalid

### getInteger

    public final int getInteger(LibrarySessionInterface session)
                         throws IfsException

  Gets this AttributeValue's representation as an int.
  Parameters:
    `session` - the session
  Returns:
    the int value
  Throws:
    `IfsException` - (IFS-10405) if this AttributeValue is null
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as an int

### getIntegerObject

    public final java.lang.Integer getIntegerObject(LibrarySessionInterface session)
                                             throws IfsException

  Gets this AttributeValue's representation as an Integer.
  Parameters:
    `session` - the session
  Returns:
    the Integer value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as an Integer

### getLong

    public final long getLong(LibrarySessionInterface session)
                       throws IfsException

  Gets this AttributeValue's representation as a long.
  Parameters:
    `session` - the session
  Returns:
    the long value
  Throws:
    `IfsException` - (IFS-10405) if this AttributeValue is null
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a long

### getLongObject

    public final java.lang.Long getLongObject(LibrarySessionInterface session)
                                       throws IfsException

  Gets this AttributeValue's representation as a Long.
  Parameters:
    `session` - the session
  Returns:
    the Long value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Long

### getDouble

    public final double getDouble(LibrarySessionInterface session)
                           throws IfsException

  Gets this AttributeValue's representation as a double.
  Parameters:
    `session` - the session
  Returns:
    the double value
  Throws:
    `IfsException` - (IFS-10405) if this AttributeValue is null
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a double

### getDoubleObject

    public final java.lang.Double getDoubleObject(LibrarySessionInterface session)
                                           throws IfsException

  Gets this AttributeValue's representation as a Double.
  Parameters:
    `session` - the session
  Returns:
    the Double value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Double

### getString

    public final java.lang.String getString(LibrarySessionInterface session)
                                     throws IfsException

  Gets this AttributeValue's representation as a String.
  Parameters:
    `session` - the session
  Returns:
    the String value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a String

### getDate

    public final java.util.Date getDate(LibrarySessionInterface session)
                                 throws IfsException

  Gets this AttributeValue's representation as a Date.
  Parameters:
    `session` - the session
  Returns:
    the Date value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Date

### getBoolean

    public final boolean getBoolean(LibrarySessionInterface session)
                             throws IfsException

  Gets this AttributeValue's representation as a boolean.
  Parameters:
    `session` - the session
  Returns:
    the boolean value
  Throws:
    `IfsException` - (IFS-10405) if this AttributeValue is null
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a boolean

### getBooleanObject

    public final java.lang.Boolean getBooleanObject(LibrarySessionInterface session)
                                             throws IfsException

  Gets this AttributeValue's representation as a Boolean.
  Parameters:
    `session` - the session
  Returns:
    the Boolean value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Boolean

### getSchemaObject

    public final SchemaObjectInterface getSchemaObject(LibrarySessionInterface session)
                                                throws IfsException

  Gets this AttributeValue's representation as a SchemaObject.
  Parameters:
    `session` - the session
  Returns:
    the SchemaObject value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a SchemaObject

### getSystemObject

    public final SystemObjectInterface getSystemObject(LibrarySessionInterface session)
                                                throws IfsException

  Gets this AttributeValue's representation as a SystemObject.
  Parameters:
    `session` - the session
  Returns:
    the SystemObject value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a SystemObject

### getPublicObject

    public final PublicObjectInterface getPublicObject(LibrarySessionInterface session)
                                                throws IfsException

  Gets this AttributeValue's representation as a PublicObject.
  Parameters:
    `session` - the session
  Returns:
    the PublicObject value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a PublicObject

### getDirectoryObject

    public final DirectoryObjectInterface getDirectoryObject(LibrarySessionInterface session)
                                                      throws IfsException

  Gets this AttributeValue's representation as a DirectoryObject.
  Parameters:
    `session` - the session
  Returns:
    the DirectoryObject value
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a DirectoryObject

### getIntegerArray

    public final int[] getIntegerArray(LibrarySessionInterface session)
                                throws IfsException

  Gets this AttributeValue's representation as an array of ints.
  Parameters:
    `session` - the session
  Returns:
    the int array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as an int[]

### getIntegerObjectArray

    public final java.lang.Integer[] getIntegerObjectArray(LibrarySessionInterface session)
                                                    throws IfsException

  Gets this AttributeValue's representation as an array of Integers.
  Parameters:
    `session` - the session
  Returns:
    the Integer array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as an Integer[]

### getLongArray

    public final long[] getLongArray(LibrarySessionInterface session)
                              throws IfsException

  Gets this AttributeValue's representation as an array of longs.
  Parameters:
    `session` - the session
  Returns:
    the long array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a long[]

### getLongObjectArray

    public final java.lang.Long[] getLongObjectArray(LibrarySessionInterface session)
                                              throws IfsException

  Gets this AttributeValue's representation as an array of Longs.
  Parameters:
    `session` - the session
  Returns:
    the Long array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Long[]

### getDoubleArray

    public final double[] getDoubleArray(LibrarySessionInterface session)
                                  throws IfsException

  Gets this AttributeValue's representation as an array of doubles.
  Parameters:
    `session` - the session
  Returns:
    the double array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a double[]

### getDoubleObjectArray

    public final java.lang.Double[] getDoubleObjectArray(LibrarySessionInterface session)
                                                  throws IfsException

  Gets this AttributeValue's representation as an array of Doubles.
  Parameters:
    `session` - the session
  Returns:
    the Double array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Double[]

### getStringArray

    public final java.lang.String[] getStringArray(LibrarySessionInterface session)
                                            throws IfsException

  Gets this AttributeValue's representation as an array of Strings.
  Parameters:
    `session` - the session
  Returns:
    the String array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a String[]

### getDateArray

    public final java.util.Date[] getDateArray(LibrarySessionInterface session)
                                        throws IfsException

  Gets this AttributeValue's representation as an array of Dates.
  Parameters:
    `session` - the session
  Returns:
    the Date array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Date[]

### getBooleanArray

    public final boolean[] getBooleanArray(LibrarySessionInterface session)
                                    throws IfsException

  Gets this AttributeValue's representation as an array of booleans.
  Parameters:
    `session` - the session
  Returns:
    the boolean array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a boolean[]

### getBooleanObjectArray

    public final java.lang.Boolean[] getBooleanObjectArray(LibrarySessionInterface session)
                                                    throws IfsException

  Gets this AttributeValue's representation as an array of Booleans.
  Parameters:
    `session` - the session
  Returns:
    the Boolean array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Boolean[]

### getSchemaObjectArray

    public final SchemaObjectInterface[] getSchemaObjectArray(LibrarySessionInterface session)
                                                       throws IfsException

  Gets this AttributeValue's representation as an array of SchemaObjects.
  Parameters:
    `session` - the session
  Returns:
    the SchemaObject array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a SchemaObject[]

### getSystemObjectArray

    public final SystemObjectInterface[] getSystemObjectArray(LibrarySessionInterface session)
                                                       throws IfsException

  Gets this AttributeValue's representation as an array of SystemObjects.
  Parameters:
    `session` - the session
  Returns:
    the SystemObject array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a SystemObject[]

### getPublicObjectArray

    public final PublicObjectInterface[] getPublicObjectArray(LibrarySessionInterface session)
                                                       throws IfsException

  Gets this AttributeValue's representation as an array of PublicObjects.
  Parameters:
    `session` - the session
  Returns:
    the PublicObject array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a PublicObject[]

### getDirectoryObjectArray

    public final DirectoryObjectInterface[] getDirectoryObjectArray(LibrarySessionInterface session)
                                                             throws IfsException

  Gets this AttributeValue's representation as an array of DirectoryObjects.
  Parameters:
    `session` - the session
  Returns:
    the DirectoryObject array; null if the AttributeValue is null
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a DirectoryObject[]

### getIntegerArray

    public final int getIntegerArray(LibrarySessionInterface session,
                                     int index)
                              throws java.lang.IndexOutOfBoundsException,
                                     IfsException

  Get the specified element of this AttributeValue's representation as an array of ints.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the int value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as an int[]

### getIntegerObjectArray

    public final java.lang.Integer getIntegerObjectArray(LibrarySessionInterface session,
                                                         int index)
                                                  throws java.lang.IndexOutOfBoundsException,
                                                         IfsException

  Get the specified element of this AttributeValue's representation as an array of Integers.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the Integer value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as an Integer[]

### getLongArray

    public final long getLongArray(LibrarySessionInterface session,
                                   int index)
                            throws java.lang.IndexOutOfBoundsException,
                                   IfsException

  Get the specified element of this AttributeValue's representation as an array of longs.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the long value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a long[]

### getLongObjectArray

    public final java.lang.Long getLongObjectArray(LibrarySessionInterface session,
                                                   int index)
                                            throws java.lang.IndexOutOfBoundsException,
                                                   IfsException

  Get the specified element of this AttributeValue's representation as an array of Longs.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the Long value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Long[]

### getDoubleArray

    public final double getDoubleArray(LibrarySessionInterface session,
                                       int index)
                                throws java.lang.IndexOutOfBoundsException,
                                       IfsException

  Get the specified element of this AttributeValue's representation as an array of doubles.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the double value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a double[]

### getDoubleObjectArray

    public final java.lang.Double getDoubleObjectArray(LibrarySessionInterface session,
                                                       int index)
                                                throws java.lang.IndexOutOfBoundsException,
                                                       IfsException

  Get the specified element of this AttributeValue's representation as an array of Doubles.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the Double value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Double[]

### getStringArray

    public final java.lang.String getStringArray(LibrarySessionInterface session,
                                                 int index)
                                          throws java.lang.IndexOutOfBoundsException,
                                                 IfsException

  Get the specified element of this AttributeValue's representation as an array of Strings.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the String value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a String[]

### getDateArray

    public final java.util.Date getDateArray(LibrarySessionInterface session,
                                             int index)
                                      throws java.lang.IndexOutOfBoundsException,
                                             IfsException

  Get the specified element of this AttributeValue's representation as an array of Dates.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the Date value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Date[]

### getBooleanArray

    public final boolean getBooleanArray(LibrarySessionInterface session,
                                         int index)
                                  throws java.lang.IndexOutOfBoundsException,
                                         IfsException

  Get the specified element of this AttributeValue's representation as an array of booleans.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the boolean value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a boolean[]

### getBooleanObjectArray

    public final java.lang.Boolean getBooleanObjectArray(LibrarySessionInterface session,
                                                         int index)
                                                  throws java.lang.IndexOutOfBoundsException,
                                                         IfsException

  Get the specified element of this AttributeValue's representation as an array of Booleans.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the Boolean value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a Boolean[]

### getSchemaObjectArray

    public final SchemaObjectInterface getSchemaObjectArray(LibrarySessionInterface session,
                                                            int index)
                                                     throws java.lang.IndexOutOfBoundsException,
                                                            IfsException

  Get the specified element of this AttributeValue's representation as an array of SchemaObjects.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the SchemaObject value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a SchemaObject[]

### getSystemObjectArray

    public final SystemObjectInterface getSystemObjectArray(LibrarySessionInterface session,
                                                            int index)
                                                     throws java.lang.IndexOutOfBoundsException,
                                                            IfsException

  Get the specified element of this AttributeValue's representation as an array of SystemObjects.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the SystemObject value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a SystemObject[]

### getPublicObjectArray

    public final PublicObjectInterface getPublicObjectArray(LibrarySessionInterface session,
                                                            int index)
                                                     throws java.lang.IndexOutOfBoundsException,
                                                            IfsException

  Get the specified element of this AttributeValue's representation as an array of PublicObjects.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the PublicObject value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a PublicObject[]

### getDirectoryObjectArray

    public final DirectoryObjectInterface getDirectoryObjectArray(LibrarySessionInterface session,
                                                                  int index)
                                                           throws java.lang.IndexOutOfBoundsException,
                                                                  IfsException

  Get the specified element of this AttributeValue's representation as an array of DirectoryObjects.
  Parameters:
    `session` - the session
    `index` - the zero-based index
  Returns:
    the DirectoryObject value of that element
  Throws:
    `IfsException` - (IFS-10406) if this AttributeValue cannot be represented as a DirectoryObject[]

### setName

    public final void setName(java.lang.String name)
                       throws IfsException

  Sets the name of this AttributeValue.
  Parameters:
    `name` - the string name
  Throws:
    `IfsException` - if the operation fails

### overrideName

    public static final AttributeValue overrideName(java.lang.String name,
                                                    AttributeValue av)
                                             throws IfsException

  Overrides the name set for this AttributeValue by cloning the AttributeValue if the name is already set.
  Parameters:
    `name` - the name
    `av` - the AttributeValue
  Returns:
    either the previously-nameless AttributeValue with the name now set, or a clone of the previously-named AttributeValue with the name altered
  Throws:
    `IfsException` - if the operation fails

### ensureUpperCaseName

    public final void ensureUpperCaseName()
                                   throws IfsException

  Ensures the name of this AttributeValue (if any) is uppercase.
  Throws:
    `IfsException` - if the operation fails

### getName

    public final java.lang.String getName()
                                   throws IfsException

  Gets the name of this AttributeValue.
  Returns:
    the name

### getDataType

    public int getDataType()
                    throws IfsException

  Gets the data type of this AttributeValue.
  Returns:
    the data type

### isArrayType

    public final boolean isArrayType()
                              throws IfsException

  Gets whether this AttributeValue is an array-type AttributeValue.
  Returns:
    whether the AttributeValue is an array type
  Throws:
    `IfsException` - if the operation fails

### isNullValue

    public boolean isNullValue()
                        throws IfsException

  Gets whether this AttributeValue is null.
  Returns:
    whether the AttributeValue is null

### getElementCount

    public int getElementCount()
                        throws IfsException

  Gets the number of elements in an array-type AttributeValue.
  Returns:
    the number of elements, or 1 if the AttributeValue is not an array type, or 0 if the AttributeValue is null

### getObject

    public java.lang.Object getObject(LibrarySessionInterface session)
                               throws IfsException

  Gets the default object representation of this AttributeValue.

  For example, the default object representation of a boolean AttributeValue is a Java Boolean.

  Parameters:
    `session` - the session
  Returns:
    the default object representation
  Throws:
    `IfsException` - (IFS-10406) if there is a AttributeValue conversion error

### toString

    public final java.lang.String toString()

  Gets the default object representation of this AttributeValue as a string.

  Equivalent to `getObject(null).toString()`. Unlike the `getString` method, the returned string is completely unformatted and unlocalized.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a string

### toString

    public final java.lang.String toString(LibrarySessionInterface sess)

  Gets the default object representation of this AttributeValue as a string.

  Equivalent to `getObject(sess).toString()`. Unlike the `getString` method, the returned string is completely unformatted and unlocalized.

  Returns:
    a string

### hashtableToArray

    public static final AttributeValue[] hashtableToArray(java.util.Hashtable hashtable)
                                                   throws IfsException

  Converts a hashtable of AttributeValues to an array.
  Parameters:
    `hashtable` - the hashtable of AttributeValues
  Returns:
    an array of AttributeValues

### arrayToHashtable

    public static final java.util.Hashtable arrayToHashtable(AttributeValue[] attrVals)
                                                      throws IfsException

  Converts an array of AttributeValues to a hashtable, hashed by name.

  AttributeValues whose name is unset are ignored.

  Parameters:
    `attrVals` - an array of AttributeValues
  Returns:
    the hashtable of AttributeValues

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD